﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;
using System.Drawing;
using Tao.OpenGl;

namespace SPS2
{
    /// <summary>
    /// 描画の基本単位
    /// </summary>
    public class DrawUnit
    {
        public enum DRAWUNIT_TYPE
        {
            PRIMITIVE,
            LETTER,
        }

        private Sprite m_Sprite;
        public Sprite Sprite { get { return m_Sprite; } } 
        public int X;
        public int Y;
        public int lineno;

        public int pauselevel;
        DRAWUNIT_TYPE type;
        public SPS2.VERTICAL_ALIGN valign;
        char ch;

        public DrawUnit(RenderContext context, SdlDotNet.Graphics.Font font, Color color, char ch)
        {
            Init(context, DRAWUNIT_TYPE.LETTER);
            m_Sprite = Sprite.RenderText(font, ch, color);
            this.ch = ch;
        }
        public DrawUnit(RenderContext context, DRAWUNIT_TYPE drawunit_type, SdlDotNet.Graphics.Surface s)
        {
            Init(context, drawunit_type);
            m_Sprite = new Sprite(s);
        }
        private void Init(RenderContext context, DRAWUNIT_TYPE drawunit_type)
        {
            pauselevel = context.pauselevel;
            lineno = context.lineno;
            type = drawunit_type;
        }
        public void Draw(Display d)
        {
            Gl.glPushMatrix();
            Gl.glTranslatef(X - d.Width / 2.0f + Sprite.Width / 2.0f, Y - d.Height / 2.0f + Sprite.Height / 2.0f, 0.0f);
            Sprite.Draw();
            Gl.glPopMatrix();
        }
    }
}
