﻿using System;
using System.Collections.Generic;
//using System.Linq;
using System.Text;

using Tao.Lua;
using System.Runtime.InteropServices;
namespace SPS2
{
    public class LuaFunction
    {
        private static Encoding encoding = Encoding.UTF8;

        public static void Register(IntPtr LL)
        {
            Lua.lua_register(LL, "sps_pause", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) <= 1);
                SPS2.GetRenderContext(L).Pause(GetDouble(L, 1, -1));
                return 0;
            });

            Lua.lua_register(LL, "sps_movecursor", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 2);
                SPS2.GetRenderContext(L).MoveCursor(GetDouble(L, 1, 0.0), GetDouble(L, 2, 0.0));
                return 0;
            });

            Lua.lua_register(LL, "sps_puttext", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) >= 1);
                LuaAssert(L, Lua.lua_gettop(L) <= 3);

                SPS2.GetRenderContext(L).PutText(
                    GetString(L, 1, ""),
                    GetString(L, 2, "0"),
                    (SPS2.VERTICAL_ALIGN)Enum.Parse(typeof(SPS2.VERTICAL_ALIGN), GetString(L, 3, "BOTTOM"), true));
                return 0;
            });

            Lua.lua_register(LL, "sps_bg", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) >= 1);
                LuaAssert(L, Lua.lua_gettop(L) <= 3);

                SPS2.GetRenderContext(L).SetBg(
                    GetString(L, 1, ""),
                    (Bg.BGSTYLE)Enum.Parse(typeof(Bg.BGSTYLE), GetString(L, 2, "TILE"), true),
                    GetDouble(L, 3, 100.0));
                return 0;
            });

            Lua.lua_register(LL, "sps_deffont", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 2);
                SPS2.GetRenderContext(L).DefFont(
                    GetString(L, 1, ""),
                    GetString(L, 2, ""));

                return 0;
            });

            Lua.lua_register(LL, "sps_deffontindex", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) >= 3);
                LuaAssert(L, Lua.lua_gettop(L) <= 5);
                SPS2.GetRenderContext(L).DefFontIndex(
                    GetString(L, 1, ""),
                    GetString(L, 2, ""),
                    GetDouble(L, 3, 0.0),
                    GetInt(L, 4, 0),
                    GetInt(L, 5, 0));
                return 0;
            });

            Lua.lua_register(LL, "sps_forecolor", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 1);
                SPS2.GetRenderContext(L).ForeColor(GetString(L, 1, ""));
                return 0;
            });

            Lua.lua_register(LL, "sps_backcolor", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 1);
                SPS2.GetRenderContext(L).BackColor(GetString(L, 1, ""));
                return 0;
            });

            Lua.lua_register(LL, "sps_puthbar", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 1);
                SPS2.GetRenderContext(L).PutHBar(GetDouble(L, 1, 0.0));
                return 0;
            });

            Lua.lua_register(LL, "sps_moveto", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 2);
                SPS2.GetRenderContext(L).MoveTo(GetDouble(L, 1, 0.0), GetDouble(L, 2, 0.0));
                return 0;
            });

            Lua.lua_register(LL, "sps_beginline", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) <= 1);
                SPS2.GetRenderContext(L).BeginLine(
                    (SPS2.HORIZONTAL_ALIGN)Enum.Parse(typeof(SPS2.HORIZONTAL_ALIGN), GetString(L, 1, "LEFT"), true));
                return 0;
            });

            Lua.lua_register(LL, "sps_endline", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 0);
                SPS2.GetRenderContext(L).EndLine();
                return 0;
            });

            Lua.lua_register(LL, "sps_hmargin", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 1);
                SPS2.GetRenderContext(L).HMargin(GetDouble(L, 1, 0.0));
                return 0;
            });

            Lua.lua_register(LL, "sps_deficon", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 2);
                SPS2.GetRenderContext(L).DefIcon(GetString(L, 1, ""), GetString(L, 2, ""));
                return 0;
            });

            Lua.lua_register(LL, "sps_puticon", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) >= 1);
                LuaAssert(L, Lua.lua_gettop(L) <= 4);
                SPS2.GetRenderContext(L).PutIcon(
                    GetString(L, 1, ""),
                    (SPS2.VERTICAL_ALIGN)Enum.Parse(typeof(SPS2.VERTICAL_ALIGN), GetString(L, 2, "BOTTOM"), true),
                    GetDouble(L, 3, 0.0),
                    GetDouble(L, 4, 0.0));
                return 0;
            });

            Lua.lua_register(LL, "sps_putimage", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) >= 1);
                LuaAssert(L, Lua.lua_gettop(L) <= 4);
                SPS2.GetRenderContext(L).PutImage(
                    GetString(L, 1, ""),
                    (SPS2.VERTICAL_ALIGN)Enum.Parse(typeof(SPS2.VERTICAL_ALIGN), GetString(L, 2, "BOTTOM"), true),
                    GetDouble(L, 3, 0.0),
                    GetDouble(L, 4, 0.0));
                return 0;
            });

            Lua.lua_register(LL, "sps_beginpage", delegate(IntPtr L)
            {
                SPS2.GetRenderContext(L).BeginPage(GetString(L, 1, ""));
                return 0;
            });

            Lua.lua_register(LL, "sps_endpage", delegate(IntPtr L)
            {
                SPS2.GetRenderContext(L).EndPage();
                return 0;
            });

            Lua.lua_register(LL, "sps_flip_function", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 1);
                SPS2.GetRenderContext(L).Flip_Function(GetString(L, 1, ""));
                return 0;
            });

            Lua.lua_register(LL, "sps_title", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 1);
                SPS2.GetRenderContext(L).SetTitle(GetString(L, 1, ""));
                return 0;
            });

            Lua.lua_register(LL, "sps_fontstyle", delegate(IntPtr L)
            {
                LuaAssert(L, Lua.lua_gettop(L) == 2);
                SPS2.GetRenderContext(L).FontStyle(GetString(L, 1, ""), GetString(L, 2, ""));
                return 0;
            });

        }

        private static bool LuaAssert(IntPtr L, bool condition)
        {
            return LuaAssert(L, condition, "");
        }
        private static bool LuaAssert(IntPtr L, bool condition, string msg)
        {
            System.Diagnostics.Debug.Assert(condition, msg);
            // TODO: LUA側エラー処理

            return condition;
        }


        private static int GetInt(IntPtr L, int idx, int defaultvalue)
        {
            int result = defaultvalue;
            if (Lua.lua_gettop(L) >= idx)
            {
                result = Lua.lua_tointeger(L, idx);
            }
            return result;
        }
        private static double GetDouble(IntPtr L, int idx, double defaultvalue)
        {
            double result = defaultvalue;
            if (Lua.lua_gettop(L) >= idx)
            {
                result = Lua.lua_tonumber(L, idx);
            }
            return result;
        }
        private static string GetString(IntPtr L, int idx, string defaultvalue)
        {
            string result = defaultvalue;
            if (Lua.lua_gettop(L) >= idx)
            {
                result = lua_tostring_utf8(L, idx);
            }
            return result;
        }
        private static string lua_tostring_utf8(IntPtr L, int i)
        {
            int strlen;
            IntPtr str = Lua.lua_tolstring(L, i, out strlen);
            if (str != IntPtr.Zero)
            {
                byte[] b = new byte[strlen];
                for (int idx = 0; idx < strlen; idx++)
                {
                    b[idx] = Marshal.ReadByte(str, idx);
                }

                string result = Encoding.UTF8.GetString(b);

                return result;
            }
            else
                return null;
        }
    }
}
