﻿using System;
using System.Reflection;
using System.Diagnostics.CodeAnalysis;

using System.Drawing;

using SdlDotNet.Core;
using SdlDotNet.Input;
using SdlDotNet.Graphics;
using Tao.OpenGl;
using System.Collections.Generic;

using Tao.Lua;
using System.Text.RegularExpressions;


namespace SPS2
{
    class SPS2Main
    {
        private static void parse_geometry(Display d, string expression)
        {
            Regex re = new Regex("([0-9]+)x([0-9]+)");
            Match m = re.Match(expression);
            if (m.Length >= 1)
            {
                d.Width = Int32.Parse(m.Groups[1].Value);
                d.Height = Int32.Parse(m.Groups[2].Value);
            }
            else
            {
                
            }
        } 
        [STAThread]
        public static void Main()
        {

            string[] args = Environment.GetCommandLineArgs();
            if (args.Length > 1)
            {
                Display d = new Display();
                d.Width = 800;
                d.Height = 600;
                d.setting.fullscreen = false;
                d.setting.showfps = true;
                d.setting.use_opengl = true;
                List<string> filenames = new List<string>();
                for (int i = 1; i < args.Length; /**/ )
                {
                    int plus = 1;
                    if (args[i].StartsWith("-"))
                    {
                        if (args[i].Length > 1)
                        {
                            switch (args[i][1])
                            {
                                case 'h':
                                case '?':
                                    usage(args[0]);
                                    break; // NOTREACHED
                                case 'f':
                                    d.setting.fullscreen = true;
                                    break;
                                case 'F':
                                    d.setting.showfps = false;
                                    break;
                                case 'G':
                                    d.setting.use_opengl = false;
                                    break;
                                case 'g':
                                    plus = 2;
                                    parse_geometry(d, args[i + 1]);
                                    break;
                            }
                        }
                        else
                        {
                            // ただの '-'
                        }

                    }
                    else
                    {
                        filenames.Add(args[i]);
                    }

                    i += plus;
                }
                SPS2 main = new SPS2(d);
                d.SPS = main; // TODO: この辺の関係は見直す必要あり・今のところはフォントの共有のため
                if (filenames.Count == 0)
                {
                    usage(args[0]);
                }

                main.Load(filenames[0]);
                main.Reshape();
                main.InitGL();
                main.MainLoop();
                //Events.Run();
            }
            else
            {
                usage(args[0]);
            }
            Environment.Exit(0);
        }

        private static void usage(string progname)
        {
            Console.WriteLine("usage: sps2 [filename.lua]");
            Environment.Exit(1);
        }
    }

}
